package net.bluebones.WorldCupKoreaJapan;

import javax.swing.ImageIcon;
import java.net.URL;

class Team {

	public String name = "";
	public int skill = 0;
	
	public boolean initialised;
	
	public int won = 0;
	public int drawn = 0;
	public int lost = 0;
	public int goalsFor = 0;
	public int goalsAgainst = 0;
	
	Team() {
		this("Uninitialised team - may be a placeholder", 0);
		initialised = false;
	}
	
	Team(String name, int skill) {
		initialised = true;
		this.name = name;
		this.skill = skill;
	}
	
	String getName() {
		return name;
	}
	
	public ImageIcon getFlag() {
		
		String name = this.getName().toLowerCase().replace(' ', '_');
		
		URL imgURL = ClassLoader.getSystemResource("net/bluebones/WorldCupKoreaJapan/images/flags/" + name + ".gif");
		
		ImageIcon img = new ImageIcon(imgURL);
		
		return img;
	}
	
	
	int points() {
		return (won * 3) + drawn;
	}
	
	int played() {
		return won + drawn + lost;
	}
	
	int goalDifference() {
		return (goalsFor - goalsAgainst);
	}
	
}
