package net.bluebones.WorldCupKoreaJapan;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.*;
import java.text.DateFormat;

/* Yes, its commentless and reams of it is redundant but its my first
Java app - gimme a break */
public class WorldCupKoreaJapan {

	JFrame frame = new JFrame("World Cup Japan/Korea 2002");
	JTabbedPane pane = new JTabbedPane();
	JScrollPane outputPanel = new JScrollPane();
	JScrollPane schedulePanel = new JScrollPane();
	JScrollPane groupsPanel = new JScrollPane();
	JPanel groupsHolder = new JPanel();
	JPanel knockoutPane = new JPanel();
	JTextArea output = new JTextArea();
	JTextArea scheduleWindow = new JTextArea();
	JLabel nextMatch = new JLabel("");
	JLabel lastMatch = new JLabel("");
	JLabel trackResults = new JLabel("");
	String trackTeamName = "England";
	int trackRes = 0;
	int numberOfWorldCups = 0;
	int goalsThisWorldCup = 0;
	int matchesThisWorldCup = 0;

	GroupTable[] groupTables = { new GroupTable(), new GroupTable(), 
		new GroupTable(), new GroupTable(), new GroupTable(), 
		new GroupTable(), new GroupTable(), new GroupTable() 
	};

	JLabel[] secondRoundLabels = { new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel() };
	JLabel[] quarterFinalLabels = { new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel(), new JLabel() };
	JLabel[] semiFinalLabels = { new JLabel(), new JLabel(), new JLabel(), new JLabel() };
	JLabel[] finalLabels = { new JLabel(), new JLabel() };
	JLabel winnerLabel = new JLabel();

	HashMap winnersTotal = new HashMap();

	String lastSearch = "";

	WorldCupDraw draw;
	GroupSchedule schedule;

	boolean started = false;
	boolean tablesWritten = false;
	boolean finished = false;
	
	Team[] winners;
	Team[] runnersUp;

	Team winner1;
	Team winner2;
	Team winner3;
	Team winner4;
	Team winner5;
	Team winner6;
	Team winner7;
	Team winner8;
	
	Team quarterFinalAWinner;
	Team quarterFinalBWinner;
	Team quarterFinalCWinner;
	Team quarterFinalDWinner;
	
	Team semiFinal1Winner;
	Team semiFinal2Winner;
	
	Team winner;
	
	// tracks progress in knockout stages
	int knockoutStages = 0;
		
	WorldCupKoreaJapan() {

		final JLabel nextMatchLabel = new JLabel("Next Match:");
		final JLabel lastMatchLabel = new JLabel("Last Match:");
		JLabel trackTeam = new JLabel(trackTeamName + ":");
		
		JScrollPane outputHolder = new JScrollPane(output);
		
		groupsHolder.setLayout(new BoxLayout(groupsHolder, BoxLayout.Y_AXIS));

		JScrollPane[] gpanes = new JScrollPane[8];

		for (int i = 0; i < WorldCupDraw.H + 1; i++) {
			gpanes[i] = new JScrollPane(groupTables[i].table);
			gpanes[i].setPreferredSize(
				new Dimension(
					groupTables[i].table.getWidth(), groupTables[i].table.getHeight()
				)
			);
			groupsHolder.add(gpanes[i]);
		}
		
		outputPanel.setPreferredSize(new Dimension(1024, 768));

		outputPanel.getViewport().add(output);
		groupsPanel.getViewport().add(groupsHolder);
		schedulePanel.getViewport().add(scheduleWindow);

		pane.addTab("Progress", outputPanel);
		pane.addTab("Groups", groupsPanel);
		pane.addTab("Schedule", schedulePanel);
		pane.addTab("Knockout", new JScrollPane(knockoutPane));
		
		Container defaultPane = frame.getContentPane();

		GridBagLayout gridbag = new GridBagLayout();
		defaultPane.setLayout(gridbag);
		
		GridBagConstraints c = new GridBagConstraints();
		c.weightx = 0.0;
		
		JToolBar tb = getJToolBar();
		c.gridwidth = 2;
		c.anchor = GridBagConstraints.WEST;
		c.gridx = 0;
		c.gridy = 0;
		gridbag.setConstraints(tb, c);
		defaultPane.add(tb);
		
		c.insets = new Insets(1, 1, 1, 1);
		c.gridwidth = 1;
		
		c.anchor = GridBagConstraints.EAST;
		c.gridx = 0;
		c.gridy = 1;
		gridbag.setConstraints(lastMatchLabel, c);
		defaultPane.add(lastMatchLabel);
		
		c.weightx = 0.5;

		c.anchor = GridBagConstraints.WEST;
		c.gridx = 1;
		c.gridy = 1;
		gridbag.setConstraints(lastMatch, c);
		defaultPane.add(lastMatch);

		c.weightx = 0.0;

		c.anchor = GridBagConstraints.EAST;
		c.gridx = 0;
		c.gridy = 2;
		gridbag.setConstraints(nextMatchLabel, c);
		defaultPane.add(nextMatchLabel);
		
		c.weightx = 0.5;
		
		c.anchor = GridBagConstraints.WEST;
		c.gridx = 1;
		c.gridy = 2;
		gridbag.setConstraints(nextMatch, c);
		defaultPane.add(nextMatch);
		
		c.weightx = 0.0;

		c.anchor = GridBagConstraints.EAST;
		c.gridx = 0;
		c.gridy = 3;
		gridbag.setConstraints(trackTeam, c);
		defaultPane.add(trackTeam);
		
		c.weightx = 0.5;
		
		c.anchor = GridBagConstraints.WEST;
		c.gridx = 1;
		c.gridy = 3;
		gridbag.setConstraints(trackResults, c);
		defaultPane.add(trackResults);
		
		c.fill = GridBagConstraints.BOTH;
						
		c.weighty = 1.0;
		c.gridwidth = 2;
		c.gridx = 0;
		c.gridy = 4;
		gridbag.setConstraints(pane, c);
		defaultPane.add(pane);
		
		frame.setJMenuBar(getJMenuBar());

		// Knockout Stages pane
		
		GridBagLayout knockoutGridbag = new GridBagLayout();
		knockoutPane.setLayout(knockoutGridbag);
		GridBagConstraints kc = new GridBagConstraints();

		kc.anchor = GridBagConstraints.WEST;
		kc.weightx = 0.5;
		
		kc.gridx = 0;
		for (int i = 0; i < secondRoundLabels.length; i++) {
			kc.gridy = (((i) / 2) * 4) + (((i + 1) / 2) * 2) + 1;
			knockoutGridbag.setConstraints(secondRoundLabels[i], kc);
			knockoutPane.add(secondRoundLabels[i]);
		}
		
		kc.gridx = 3;
		for (int i = 0; i < quarterFinalLabels.length; i++) {
			kc.gridy = (i * 6) + 2;
			knockoutGridbag.setConstraints(quarterFinalLabels[i], kc);
			knockoutPane.add(quarterFinalLabels[i]);
		}
		
		kc.gridx = 6;
		for (int i = 0; i < semiFinalLabels.length; i++) {
			kc.gridy = (i * 12) + 4;
			knockoutGridbag.setConstraints(semiFinalLabels[i], kc);
			knockoutPane.add(semiFinalLabels[i]);
		}
		
		kc.gridx = 9;
		
		kc.gridy = 12;
		knockoutGridbag.setConstraints(finalLabels[0], kc);
		knockoutPane.add(finalLabels[0]);
		
		kc.gridy = 36;
		knockoutGridbag.setConstraints(finalLabels[1], kc);
		knockoutPane.add(finalLabels[1]);
		
		kc.gridx = 12;
		kc.gridy = 24;
		knockoutGridbag.setConstraints(winnerLabel, kc);
		knockoutPane.add(winnerLabel);
		

		frame.addWindowListener(
			new WindowAdapter() {
			    	public void windowClosing(WindowEvent e) {
						System.exit(0);
			    	}
			}
		);

		frame.pack();
		frame.setVisible(true);

	}
	
	public static void main(String[] args) {
			WorldCupKoreaJapan wc = new WorldCupKoreaJapan();
	}
	
	private static char getGroupLetter(int i) {
		
		char c = 'x';
		
		if (i == 0) {
			c = 'A';
		} else if (i == 1) {
			c = 'B';
		} else if (i == 2) {
			c = 'C';
		} else if (i == 3) {
			c = 'D';
		} else if (i == 4) {
			c = 'E';
		} else if (i == 5) {
			c = 'F';
		} else if (i == 6) {
			c = 'G';
		} else if (i == 7) {
			c = 'H';
		}
		
		return c;
	}
	
	private void newWorldCup(boolean useActualDraw) {
		numberOfWorldCups++;
		goalsThisWorldCup = 0;
		matchesThisWorldCup = 0;
		output.setText("");
		started = true;
		tablesWritten = false;
		finished = false;
		knockoutStages = 0;
		draw = new WorldCupDraw(useActualDraw);
		schedule = new GroupSchedule(draw);
		lastMatch.setText("");
		nextMatch.setText("[R1] " + schedule.getNextFixtureDetails());
		
		secondRoundLabels[0].setText("Winner E");
		secondRoundLabels[1].setText("Runner Up B");
		secondRoundLabels[2].setText("Winner G");
		secondRoundLabels[3].setText("Runner Up D");
		secondRoundLabels[4].setText("Winner B");
		secondRoundLabels[5].setText("Runner Up E");
		secondRoundLabels[6].setText("Winner D");
		secondRoundLabels[7].setText("Runner Up G");
		secondRoundLabels[8].setText("Winner A");
		secondRoundLabels[9].setText("Runner Up F");
		secondRoundLabels[10].setText("Winner C");
		secondRoundLabels[11].setText("Runner Up H");
		secondRoundLabels[12].setText("Winner F");
		secondRoundLabels[13].setText("Runner Up A");
		secondRoundLabels[14].setText("Winner H");
		secondRoundLabels[15].setText("Runner Up C");

		for (int i = 0; i < secondRoundLabels.length; i++) {
			secondRoundLabels[i].setIcon(null);
		}

		for (int i = 0; i < quarterFinalLabels.length; i++) {
			quarterFinalLabels[i].setText("Winner R16 " + (i + 1));
			quarterFinalLabels[i].setIcon(null);
		}
				
		semiFinalLabels[0].setText("Winner QF A");
		semiFinalLabels[1].setText("Winner QF B");
		semiFinalLabels[2].setText("Winner QF C");
		semiFinalLabels[3].setText("Winner QF D");
		
		for (int i = 0; i < semiFinalLabels.length; i++) {
			semiFinalLabels[i].setIcon(null);
		}
		
		finalLabels[0].setText("Winner SF 1");
		finalLabels[1].setText("Winner SF 2");

		for (int i = 0; i < finalLabels.length; i++) {
			finalLabels[i].setIcon(null);
		}

		winnerLabel.setText("World Cup Winner 2002");
		winnerLabel.setIcon(null);

	}
	
	private void runWorldCup() {

		lastMatch.setText(nextMatch.getText());
		
		if (! schedule.end()) {
			Match m = schedule.getNextMatch();
			m.playMatch();
			for (int i = 0; i < draw.groups.length; i++) {
				draw.groups[i].graphicTable();
			}
			output.setCaretPosition(output.getText().length());
			println();
			println("Next match: " + schedule.getNextFixtureDetails());
			if (! schedule.end()) {
				nextMatch.setText("[R1] " + schedule.getNextFixtureDetails());
			// when last group match just completed ...
			} else {
				nextMatch.setText(
					"[R2] " + 
					draw.groups[WorldCupDraw.E].getTeamRanked(0).getName() 
					+ " v " + 
					draw.groups[WorldCupDraw.B].getTeamRanked(1).getName()
				);
			
				winners = new Team[draw.groups.length];
				runnersUp = new Team[draw.groups.length];
	
				for (int i = 0; i < draw.groups.length; i++) {
					winners[i] = draw.groups[i].getTeamRanked(0);
				}
			
				for (int i = 0; i < draw.groups.length; i++) {
					runnersUp[i] = draw.groups[i].getTeamRanked(1);
				}
				
				secondRoundLabels[0].setText(winners[WorldCupDraw.E].getName());
				secondRoundLabels[0].setIcon(winners[WorldCupDraw.E].getFlag());
				secondRoundLabels[1].setText(runnersUp[WorldCupDraw.B].getName());
				secondRoundLabels[1].setIcon(runnersUp[WorldCupDraw.B].getFlag());
				secondRoundLabels[2].setText(winners[WorldCupDraw.G].getName());
				secondRoundLabels[2].setIcon(winners[WorldCupDraw.G].getFlag());
				secondRoundLabels[3].setText(runnersUp[WorldCupDraw.D].getName());
				secondRoundLabels[3].setIcon(runnersUp[WorldCupDraw.D].getFlag());
				secondRoundLabels[4].setText(winners[WorldCupDraw.B].getName());
				secondRoundLabels[4].setIcon(winners[WorldCupDraw.B].getFlag());
				secondRoundLabels[5].setText(runnersUp[WorldCupDraw.E].getName());
				secondRoundLabels[5].setIcon(runnersUp[WorldCupDraw.E].getFlag());
				secondRoundLabels[6].setText(winners[WorldCupDraw.D].getName());
				secondRoundLabels[6].setIcon(winners[WorldCupDraw.D].getFlag());
				secondRoundLabels[7].setText(runnersUp[WorldCupDraw.G].getName());
				secondRoundLabels[7].setIcon(runnersUp[WorldCupDraw.G].getFlag());
				secondRoundLabels[8].setText(winners[WorldCupDraw.A].getName());
				secondRoundLabels[8].setIcon(winners[WorldCupDraw.A].getFlag());
				secondRoundLabels[9].setText(runnersUp[WorldCupDraw.F].getName());
				secondRoundLabels[9].setIcon(runnersUp[WorldCupDraw.F].getFlag());
				secondRoundLabels[10].setText(winners[WorldCupDraw.C].getName());
				secondRoundLabels[10].setIcon(winners[WorldCupDraw.C].getFlag());
				secondRoundLabels[11].setText(runnersUp[WorldCupDraw.H].getName());
				secondRoundLabels[11].setIcon(runnersUp[WorldCupDraw.H].getFlag());
				secondRoundLabels[12].setText(winners[WorldCupDraw.F].getName());
				secondRoundLabels[12].setIcon(winners[WorldCupDraw.F].getFlag());
				secondRoundLabels[13].setText(runnersUp[WorldCupDraw.A].getName());
				secondRoundLabels[13].setIcon(runnersUp[WorldCupDraw.A].getFlag());
				secondRoundLabels[14].setText(winners[WorldCupDraw.H].getName());
				secondRoundLabels[14].setIcon(winners[WorldCupDraw.H].getFlag());
				secondRoundLabels[15].setText(runnersUp[WorldCupDraw.C].getName());
				secondRoundLabels[15].setIcon(runnersUp[WorldCupDraw.C].getFlag());

			}
	
			return;
		}
		
		knockoutStages++;
		
		if (knockoutStages == 1) {
			
			// Write out output window version of group tables
			for (int i = 0; i < draw.groups.length; i++) {
				draw.groups[i].writeTable();
			}

			println();
			println("-----Second Round-----");
			
			winner1 = new Match(
				winners[WorldCupDraw.E], runnersUp[WorldCupDraw.B],
				new GregorianCalendar(2002, 6, 15, 15, 30),
				Match.KNOCKOUT
			).playMatch();
			quarterFinalLabels[0].setText(winner1.getName());
			quarterFinalLabels[0].setIcon(winner1.getFlag());
			nextMatch.setText("[R2] " + winners[WorldCupDraw.A].getName() + " v " + 
				    runnersUp[WorldCupDraw.F].getName());

		} else if (knockoutStages == 2) {
	
			winner5 = new Match(
					winners[WorldCupDraw.A], runnersUp[WorldCupDraw.F],
					new GregorianCalendar(2002, 6, 15, 20, 30),
					Match.KNOCKOUT
				).playMatch();
			quarterFinalLabels[4].setText(winner5.getName());
			quarterFinalLabels[4].setIcon(winner5.getFlag());
			nextMatch.setText("[R2] " + winners[WorldCupDraw.F].getName() + " v " + 
				    runnersUp[WorldCupDraw.A].getName());
	
		} else if (knockoutStages == 3) {
	
			winner6 = new Match(
					winners[WorldCupDraw.F], runnersUp[WorldCupDraw.A],
					new GregorianCalendar(2002, 6, 16, 15, 30),
					Match.KNOCKOUT
				).playMatch();
			quarterFinalLabels[6].setText(winner6.getName());
			quarterFinalLabels[6].setIcon(winner6.getFlag());
			nextMatch.setText("[R2] " + winners[WorldCupDraw.B].getName() + " v " + 
				    runnersUp[WorldCupDraw.E].getName());
		
		} else if (knockoutStages == 4) {
		
			winner2 = new Match(
					winners[WorldCupDraw.B], runnersUp[WorldCupDraw.E],
					new GregorianCalendar(2002, 6, 16, 20, 30),
					Match.KNOCKOUT
				).playMatch();
			quarterFinalLabels[2].setText(winner2.getName());
			quarterFinalLabels[2].setIcon(winner2.getFlag());
			nextMatch.setText("[R2] " + winners[WorldCupDraw.G].getName() + " v " + 
				    runnersUp[WorldCupDraw.D].getName());

		
		} else if (knockoutStages == 5) {

			winner3 = new Match(
					winners[WorldCupDraw.G], runnersUp[WorldCupDraw.D],
					new GregorianCalendar(2002, 6, 17, 15, 30),
					Match.KNOCKOUT
				).playMatch();
			quarterFinalLabels[1].setText(winner3.getName());
			quarterFinalLabels[1].setIcon(winner3.getFlag());
			nextMatch.setText("[R2] " + winners[WorldCupDraw.C].getName() + " v " + 
				    runnersUp[WorldCupDraw.H].getName());

		
		} else if (knockoutStages == 6) {		
		
			winner7 = new Match(
					winners[WorldCupDraw.C], runnersUp[WorldCupDraw.H],
					new GregorianCalendar(2002, 6, 17, 20, 30),
					Match.KNOCKOUT
				).playMatch();
			quarterFinalLabels[5].setText(winner7.getName());
			quarterFinalLabels[5].setIcon(winner7.getFlag());
			nextMatch.setText("[R2] " + winners[WorldCupDraw.H].getName() + " v " + 
				    runnersUp[WorldCupDraw.C].getName());


		} else if (knockoutStages == 7) {

			winner8 = new Match(
					winners[WorldCupDraw.H], runnersUp[WorldCupDraw.C],
					new GregorianCalendar(2002, 6, 18, 15, 30),
					Match.KNOCKOUT
				).playMatch();
			quarterFinalLabels[7].setText(winner8.getName());
			quarterFinalLabels[7].setIcon(winner8.getFlag());
			nextMatch.setText("[R2] " + winners[WorldCupDraw.D].getName() + " v " + 
				    runnersUp[WorldCupDraw.G].getName());


		} else if (knockoutStages == 8) {
		
			winner4 = new Match(
					winners[WorldCupDraw.D], runnersUp[WorldCupDraw.G],
					new GregorianCalendar(2002, 6, 18, 20, 30),
					Match.KNOCKOUT
				).playMatch();
			quarterFinalLabels[3].setText(winner4.getName());
			quarterFinalLabels[3].setIcon(winner4.getFlag());
			nextMatch.setText("[QF] " + winner5.getName() + " v " + 
				    winner7.getName());
		
		} else if (knockoutStages == 9) {
		
			println();
			println("-----Quarter-Finals-----");	

			quarterFinalCWinner = new Match(
					winner5, winner7,
					new GregorianCalendar(2002, 6, 21, 15, 30),
					Match.KNOCKOUT
				).playMatch();
			semiFinalLabels[2].setText(quarterFinalCWinner.getName());
			semiFinalLabels[2].setIcon(quarterFinalCWinner.getFlag());
			nextMatch.setText("[QF] " + winner1.getName() + " v " + 
				    winner3.getName());

		} else if (knockoutStages == 10) {
	
			quarterFinalAWinner = new Match(
					winner1, winner3,
					new GregorianCalendar(2002, 6, 21, 20, 30),
					Match.KNOCKOUT
				).playMatch();
			semiFinalLabels[0].setText(quarterFinalAWinner.getName());	
			semiFinalLabels[0].setIcon(quarterFinalAWinner.getFlag());	
			nextMatch.setText("[QF] " + winner2.getName() + " v " + 
				    winner4.getName());
		

		} else if (knockoutStages == 11) {
	
			quarterFinalBWinner = new Match(
					winner2, winner4,
					new GregorianCalendar(2002, 6, 22, 15, 20),
					Match.KNOCKOUT
				).playMatch();
			semiFinalLabels[1].setText(quarterFinalBWinner.getName());
			semiFinalLabels[1].setIcon(quarterFinalBWinner.getFlag());
			nextMatch.setText("[QF] " + winner6.getName() + " v " + 
				    winner8.getName());
		
		} else if (knockoutStages == 12) {
			
			quarterFinalDWinner = new Match(
					winner6, winner8,
					new GregorianCalendar(2002, 6, 22, 18, 30),
					Match.KNOCKOUT
				).playMatch();
			semiFinalLabels[3].setText(quarterFinalDWinner.getName());
			semiFinalLabels[3].setIcon(quarterFinalDWinner.getFlag());
			nextMatch.setText("[SF] " + quarterFinalAWinner.getName() + " v " + 
				    quarterFinalBWinner.getName());
		

		} else if (knockoutStages == 13) {

			println();
			println("-----Semi-Finals-----");
		
			semiFinal1Winner = new Match(
					quarterFinalAWinner, quarterFinalBWinner,
					new GregorianCalendar(2002, 6, 25, 20, 30),
					Match.KNOCKOUT
				).playMatch();
			finalLabels[0].setText(semiFinal1Winner.getName());
			finalLabels[0].setIcon(semiFinal1Winner.getFlag());
			nextMatch.setText("[SF] " + quarterFinalCWinner.getName() + " v " + 
				    quarterFinalDWinner.getName());
		

		} else if (knockoutStages == 14) {
			
			semiFinal2Winner = new Match(
					quarterFinalCWinner, quarterFinalDWinner,
					new GregorianCalendar(2002, 6, 26, 20, 30),
					Match.KNOCKOUT
				).playMatch();
			finalLabels[1].setText(semiFinal2Winner.getName());
			finalLabels[1].setIcon(semiFinal2Winner.getFlag());
			nextMatch.setText("[Final] " + semiFinal1Winner.getName() + " v " + 
				    semiFinal2Winner.getName());
		

		} else if (knockoutStages == 15) {
				
			// Should do 3rd/4th place match here
			
			println();
			println("-----Final-----");
	
			winner = new Match(
					semiFinal1Winner, semiFinal2Winner,
					new GregorianCalendar(2002, 6, 30, 20, 0),
					Match.KNOCKOUT
				).playMatch();
			winnerLabel.setText(winner.getName());
			winnerLabel.setIcon(winner.getFlag());
			nextMatch.setText("[Winner] " + winner.getName());

			println();
			println("World Cup 2002 Winner - " + 
			    winner.name);
		    
			println();
			println(goalsThisWorldCup + " goals in " + matchesThisWorldCup + " (avg: " + ((float) goalsThisWorldCup / (float) matchesThisWorldCup) + ")");
		
			int soFar;
		
			if (winnersTotal.containsKey(winner.getName())) {   
				soFar = Integer.parseInt(winnersTotal.get(winner.getName()).toString());
				soFar++;
			} else {
				soFar = 1;
			}
			winnersTotal.put(winner.getName(), Integer.toString(soFar));
		
			finished = true;
			
			getWinnersSoFar();
			
		}
		 
	}
	
	private void getWinnersSoFar() {

		Object value = new Object();
		Object key;
		
		println();

		for (Iterator i = winnersTotal.keySet().iterator(); i.hasNext(); ) {

			key = i.next();
			value = winnersTotal.get(key);
			
			println(key + ": " + value);
			
		}
			
	}
	
	private JMenuBar getJMenuBar() {
		
		JMenu fileMenu = new JMenu("File"); 
	 	JMenu editMenu = new JMenu("Edit");
	 	JMenu matchesMenu = new JMenu("Matches");
	 	JMenu helpMenu = new JMenu("Help");
	 	
	 	fileMenu.setMnemonic(KeyEvent.VK_F);
	 	editMenu.setMnemonic(KeyEvent.VK_E);
	 	matchesMenu.setMnemonic(KeyEvent.VK_M);
	 	helpMenu.setMnemonic(KeyEvent.VK_H);
	    		
		JMenuItem fileNew = new JMenuItem("New", KeyEvent.VK_N);
		fileNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, Event.CTRL_MASK));
		JMenuItem fileNewRandomDraw = new JMenuItem("New Random Draw", KeyEvent.VK_E);
		fileNewRandomDraw.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E, Event.CTRL_MASK));
		JMenuItem fileExit = new JMenuItem("Exit", KeyEvent.VK_X);
		
		fileNew.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// Uncomment for loop for multiple world cups
					//for (int i = 0; i < 1000; i++) {
						newWorldCup(true);
						//playAllMatches();
					//}
				}
			}
		);
		
		fileNewRandomDraw.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
						newWorldCup(false);
				}
			}
		);
		
		fileExit.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					System.exit(0);
				}
			}
		);

		fileMenu.add(fileNew);
		fileMenu.add(fileNewRandomDraw);
		fileMenu.add(fileExit);

		JMenuItem editFind = new JMenuItem("Find", KeyEvent.VK_F);
		editFind.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F, Event.CTRL_MASK));
		
		editFind.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					find();
				}
			}
		);
		
		JMenuItem editFindNext = new JMenuItem("Find Next", KeyEvent.VK_N);
		editFindNext.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3, 0));
		
		editFindNext.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					doFindNext();
				}
			}
		);

		editMenu.add(editFind);
		editMenu.add(editFindNext);
		
		JMenuItem matchesContinue = new JMenuItem("Continue", KeyEvent.VK_C);
		matchesContinue.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T, Event.CTRL_MASK));
		
		matchesContinue.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if ((started) && (! finished)) {
						runWorldCup();
					}
				}
			}
		);
		
		JMenuItem matchesPlayAll = new JMenuItem("Play All", KeyEvent.VK_P);
		matchesPlayAll.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L, Event.CTRL_MASK));

		matchesPlayAll.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
						playAllMatches();		
				}
			}
		);
		
		matchesMenu.add(matchesContinue);
		matchesMenu.add(matchesPlayAll);
		
		JMenuItem helpAbout = new JMenuItem("About", KeyEvent.VK_A);
		
		helpAbout.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// pop up a dialog about me!
					JOptionPane.showMessageDialog(frame, 
					    "Written by Thomas Baker 2001, freeware",
					    "World Cup 2002",
					    JOptionPane.INFORMATION_MESSAGE);
				}
			}
		);
		
		helpMenu.add(helpAbout);

		JMenuBar mb = new JMenuBar();

   		mb.add(fileMenu);
   		mb.add(editMenu);
   		mb.add(matchesMenu);
   		mb.add(helpMenu);

		return mb;

	}
	
	private JToolBar getJToolBar() {
		
		JToolBar toolBar = new JToolBar();
		
		JButton continueButton = new JButton(
			new ImageIcon(
				ClassLoader.getSystemResource("net/bluebones/WorldCupKoreaJapan/images/StepForward24.gif")
			, "Continue")
		);
		continueButton.setToolTipText("Continue");

		continueButton.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if ((started) && (! finished)) {
						runWorldCup();
					}
				}
			}
		);

		JButton playAllButton = new JButton(
			new ImageIcon(
				ClassLoader.getSystemResource("net/bluebones/WorldCupKoreaJapan/images/FastForward24.gif")
			, "Play All")
		);
		playAllButton.setToolTipText("Play All");
		
		playAllButton.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					playAllMatches();
				}
			}
		);

		
		JButton newButton = new JButton(
			new ImageIcon(
				ClassLoader.getSystemResource("net/bluebones/WorldCupKoreaJapan/images/New24.gif")
			, "New")
		);
		newButton.setToolTipText("New");		
		
		newButton.addActionListener(
			new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						newWorldCup(true);
					}
			}
		);

		toolBar.add(newButton);
		toolBar.add(continueButton);
		toolBar.add(playAllButton);
		toolBar.setFloatable(false);
		
		return toolBar;

	}
	
	private void playAllMatches() {
		
		if ((started) && (! finished)) {
			int all = schedule.size();
			if (all > 0) {
				for (int i = 0; i < all; i++) {
					runWorldCup();
				}
			}
			// this will need to be 15 if 3rd/4th match added
			for (int i = 0; i < 15; i++) {
				knockoutStages = i;
				runWorldCup();
			}
		}
		
	}
	
	public void find() {

		// This is case sensitive and probably shouldn't be

		JTextArea toSearch = getToSearch();

		if (toSearch == null) { return; }
		
		String findWhat = (String) JOptionPane.showInputDialog(frame,
			"Find What:", "Find", 
		    JOptionPane.QUESTION_MESSAGE, null, null, lastSearch);
		
		// Save for later searches
		if (findWhat != null) {
			lastSearch = findWhat;
			doFind(findWhat, toSearch.getCaretPosition(), toSearch);
		}
		
	}
	
	public JTextArea getToSearch() {

		Component focusedTab = pane.getSelectedComponent();
		JTextArea toSearch;		
		if (focusedTab == schedulePanel) {
			toSearch = scheduleWindow;
		} else if (focusedTab == outputPanel) {
			toSearch = output;
		} else {
			JOptionPane.showMessageDialog(
				frame, "Cannot search this panel", 
				"Error", JOptionPane.WARNING_MESSAGE
			);
			toSearch = null;
		}
		
		return toSearch;
	
	}
	
	public void doFind(String findWhat, int caretPos, JTextArea toSearch) {
			
		int startPos = toSearch.getText().indexOf(findWhat, caretPos);
			
		if (startPos != -1) {
			
			toSearch.select(startPos, startPos + findWhat.length());
			
		} else if (caretPos != 0) {
			
			doFind(findWhat, 0, toSearch);
			
		} else {
			
			JOptionPane.showMessageDialog(frame,
				"\"" + findWhat + "\" not found", 
				"Search String Not Found", 
				JOptionPane.INFORMATION_MESSAGE);
		
		}
	}
	
	public void doFindNext() {
		
		JTextArea toSearch = getToSearch();
	
		doFind(lastSearch, toSearch.getCaretPosition(), toSearch);
		
	}
	
		
	public void print(String text) {
		
		output.append(text);
		
	}

	public void print(int i) {
		
		output.append(new Integer(i).toString());
		
	}
	
	public void println(String text) {
		
		output.append(text + "\n");
		
	}
	
	public void println() {
		
		output.append("\n");
	}

	
	public void println(int i) {
		
		output.append(new Integer(i).toString() + "\n");
		
	}
	
	class GroupSchedule {
	
		LinkedList schedule = new LinkedList();
		
		GroupSchedule() {
			println("Draw undefined");
			System.exit(0);
		}
		
		GroupSchedule(WorldCupDraw draw) {
			
			
			// 30th May
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.A].teams[0], 
					draw.groups[WorldCupDraw.A].teams[1],
					new GregorianCalendar(2002, 5, 30, 20, 30),
					Match.GROUP
				)
			);		
			
			// 1st June
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.E].teams[2],
					draw.groups[WorldCupDraw.E].teams[3],
					new GregorianCalendar(2002, 6, 1, 15, 30),
					Match.GROUP
				)
			);
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.A].teams[2],
					draw.groups[WorldCupDraw.A].teams[3],
					new GregorianCalendar(2002, 6, 1, 18, 0),
					Match.GROUP
				)
			);
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.E].teams[0],
					draw.groups[WorldCupDraw.E].teams[1],
					new GregorianCalendar(2002, 6, 1, 20, 30),
					Match.GROUP
				)
			);
			
			// 2nd June
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.F].teams[2],
					draw.groups[WorldCupDraw.F].teams[3],
					new GregorianCalendar(2002, 6, 2, 14, 30),
					Match.GROUP
				)
			);
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.B].teams[2],
					draw.groups[WorldCupDraw.B].teams[3],
					new GregorianCalendar(2002, 6, 2, 16, 30),
					Match.GROUP
				)
			);
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.F].teams[0],
					draw.groups[WorldCupDraw.F].teams[1],
					new GregorianCalendar(2002, 6, 2, 18, 30),
					Match.GROUP
				)
			);
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.B].teams[0],
					draw.groups[WorldCupDraw.B].teams[1],
					new GregorianCalendar(2002, 6, 2, 20, 30),
					Match.GROUP
				)
			);
			
			// 3rd June
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.G].teams[2],
					draw.groups[WorldCupDraw.G].teams[3],
					new GregorianCalendar(2002, 6, 3, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.C].teams[0],
					draw.groups[WorldCupDraw.C].teams[1],
					new GregorianCalendar(2002, 6, 3, 18, 00),
					Match.GROUP
				)
			);
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.G].teams[0],
					draw.groups[WorldCupDraw.G].teams[1],
					new GregorianCalendar(2002, 6, 3, 20, 30),
					Match.GROUP
				)
			);
			
			
			// 4th June
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.C].teams[2],
					draw.groups[WorldCupDraw.C].teams[3],
					new GregorianCalendar(2002, 6, 4, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.H].teams[0],
					draw.groups[WorldCupDraw.H].teams[1],
					new GregorianCalendar(2002, 6, 4, 18, 0),
					Match.GROUP
				)
			);
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.D].teams[0],
					draw.groups[WorldCupDraw.D].teams[1],
					new GregorianCalendar(2002, 6, 4, 20, 30),
					Match.GROUP
				)
			);
			
			// 5th June
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.H].teams[2],
					draw.groups[WorldCupDraw.H].teams[3],
					new GregorianCalendar(2002, 6, 5, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.D].teams[2],
					draw.groups[WorldCupDraw.D].teams[3],
					new GregorianCalendar(2002, 6, 5, 18, 00),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.E].teams[0],
					draw.groups[WorldCupDraw.E].teams[2],
					new GregorianCalendar(2002, 6, 5, 20, 30),
					Match.GROUP
				)
			);
			
			// 6th June
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.A].teams[0],
					draw.groups[WorldCupDraw.A].teams[2],
					new GregorianCalendar(2002, 6, 6, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.E].teams[3],
					draw.groups[WorldCupDraw.E].teams[1],
					new GregorianCalendar(2002, 6, 6, 18, 0),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.A].teams[3],
					draw.groups[WorldCupDraw.A].teams[1],
					new GregorianCalendar(2002, 6, 6, 20, 30),
					Match.GROUP
				)
			);
			
			// 7th June
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.F].teams[3],
					draw.groups[WorldCupDraw.F].teams[1],
					new GregorianCalendar(2002, 6, 7, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.B].teams[0],
					draw.groups[WorldCupDraw.B].teams[2],
					new GregorianCalendar(2002, 6, 7, 18, 0),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.F].teams[0],
					draw.groups[WorldCupDraw.F].teams[2],
					new GregorianCalendar(2002, 6, 7, 20, 30),
					Match.GROUP
				)
			);
			
			// 8th June
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.B].teams[3],
					draw.groups[WorldCupDraw.B].teams[1],
					new GregorianCalendar(2002, 6, 8, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.G].teams[0],
					draw.groups[WorldCupDraw.G].teams[2],
					new GregorianCalendar(2002, 6, 8, 18, 0),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.C].teams[0],
					draw.groups[WorldCupDraw.C].teams[2],
					new GregorianCalendar(2002, 6, 8, 20, 30),
					Match.GROUP
				)
			);
			
			// 9th June
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.G].teams[3],
					draw.groups[WorldCupDraw.G].teams[1],
					new GregorianCalendar(2002, 6, 9, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.C].teams[3],
					draw.groups[WorldCupDraw.C].teams[1],
					new GregorianCalendar(2002, 6, 9, 18, 00),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.H].teams[0],
					draw.groups[WorldCupDraw.H].teams[2],
					new GregorianCalendar(2002, 6, 9, 20, 30),
					Match.GROUP
				)
			);
			
			// 10th June
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.D].teams[0],
					draw.groups[WorldCupDraw.D].teams[2],
					new GregorianCalendar(2002, 6, 10, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.H].teams[3],
					draw.groups[WorldCupDraw.H].teams[1],
					new GregorianCalendar(2002, 6, 10, 18, 0),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.D].teams[1],
					draw.groups[WorldCupDraw.D].teams[3],
					new GregorianCalendar(2002, 6, 10, 20, 30),
					Match.GROUP
				)
			);
			
			// 11th June
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.A].teams[3],
					draw.groups[WorldCupDraw.A].teams[0],
					new GregorianCalendar(2002, 6, 11, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.A].teams[1],
					draw.groups[WorldCupDraw.A].teams[2],
					new GregorianCalendar(2002, 6, 11, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.E].teams[1],
					draw.groups[WorldCupDraw.E].teams[2],
					new GregorianCalendar(2002, 6, 11, 20, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.E].teams[3],
					draw.groups[WorldCupDraw.E].teams[0],
					new GregorianCalendar(2002, 6, 11, 20, 30),
					Match.GROUP
				)
			);
			
			// 12th June
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.F].teams[3],
					draw.groups[WorldCupDraw.F].teams[0],
					new GregorianCalendar(2002, 6, 12, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.F].teams[1],
					draw.groups[WorldCupDraw.F].teams[2],
					new GregorianCalendar(2002, 6, 12, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.B].teams[3],
					draw.groups[WorldCupDraw.B].teams[0],
					new GregorianCalendar(2002, 6, 12, 20, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.B].teams[1],
					draw.groups[WorldCupDraw.B].teams[2],
					new GregorianCalendar(2002, 6, 12, 20, 30),
					Match.GROUP
				)
			);
			
			// 13th June
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.C].teams[0],
					draw.groups[WorldCupDraw.C].teams[3],
					new GregorianCalendar(2002, 6, 13, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.C].teams[1],
					draw.groups[WorldCupDraw.C].teams[2],
					new GregorianCalendar(2002, 6, 13, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.G].teams[1],
					draw.groups[WorldCupDraw.G].teams[2],
					new GregorianCalendar(2002, 6, 13, 20, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.G].teams[3],
					draw.groups[WorldCupDraw.G].teams[0],
					new GregorianCalendar(2002, 6, 13, 20, 30),
					Match.GROUP
				)
			);
			
			// 14th June		
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.H].teams[1],
					draw.groups[WorldCupDraw.H].teams[2],
					new GregorianCalendar(2002, 6, 14, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.H].teams[3],
					draw.groups[WorldCupDraw.H].teams[0],
					new GregorianCalendar(2002, 6, 14, 15, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.D].teams[1],
					draw.groups[WorldCupDraw.D].teams[2],
					new GregorianCalendar(2002, 6, 14, 20, 30),
					Match.GROUP
				)
			);
			
			
			schedule.add(
				new Match(
					draw.groups[WorldCupDraw.D].teams[3],
					draw.groups[WorldCupDraw.D].teams[0],
					new GregorianCalendar(2002, 6, 14, 20, 30),
					Match.GROUP
				)
			);		
							
			String scheduleText = "";
			Match match;
			for (int i = 0; i < schedule.size(); i++) {
				match = (Match) schedule.get(i);
				scheduleText += 
					match.matchDate + "\n" +
				    match.teams[0].name + " v " + 
				    match.teams[1].name + "\n\n";
			}
			scheduleWindow.setText(scheduleText);
			
		}
	
		public Match getNextMatch() {
			
			Match match = (Match) schedule.getFirst();
			schedule.remove(match);
			return match;
			
		}
		
		public String getNextFixtureDetails() {
			
			if (schedule.size() > 0) {
				Match match = (Match) schedule.getFirst();
				return match.teams[0].name + " v " + 
				    match.teams[1].name;
			} else {
				return "All group games completed";
			}
			
		}
		
		public boolean end() {
			
			boolean end = false;
			
			if (schedule.size() > 0) {
				end = false;
			} else {
				end = true;
			}
			
			return end;
		}
		
		public int size() {
		
			return schedule.size();
		
		}
	
	}
	
	
		
	class WorldCupDraw {
		
		static final int A = 0;
		static final int B = 1;
		static final int C = 2;
		static final int D = 3;
		static final int E = 4;
		static final int F = 5;
		static final int G = 6;
		static final int H = 7;
		
		static final int HOME_ADVANTAGE = 50;
		
		public Grouping[] groups = { 
			new Grouping(WorldCupDraw.A),
			new Grouping(WorldCupDraw.B),
			new Grouping(WorldCupDraw.C),
			new Grouping(WorldCupDraw.D),
			new Grouping(WorldCupDraw.E),
			new Grouping(WorldCupDraw.F),
			new Grouping(WorldCupDraw.G),
			new Grouping(WorldCupDraw.H)
		};
	
		WorldCupDraw(boolean actual) {
			
			// Seeds
			Team france = new Team("France", 816);
			Team japan = new Team("Japan", 633 + HOME_ADVANTAGE);
			Team koreaRepublic = new Team("Korea Republic", 599 + HOME_ADVANTAGE);
			Team brazil = new Team("Brazil", 799);
			Team argentina = new Team("Argentina", 796);
			Team italy = new Team("Italy", 739);
			Team spain = new Team("Spain", 730);
			Team germany = new Team("Germany", 695);
			
			// European Teams
			Team denmark = new Team("Denmark", 682);
			Team belgium = new Team("Belgium", 625);
			Team croatia = new Team("Croatia", 685);
			Team portugal = new Team("Portugal", 739);
			Team turkey = new Team("Turkey", 624);
			Team russia = new Team("Russia", 660);
			Team sweden = new Team("Sweden", 678);
			Team slovenia = new Team("Slovenia", 633);
			Team england = new Team("England", 716);
			Team republicOfIreland = new Team("Republic of Ireland", 669);
			Team poland = new Team("Poland", 632);
			
			// CAF and CONCACAF
			Team usa = new Team("USA", 670);
			Team nigeria = new Team("Nigeria", 602);
			Team costaRica = new Team("Costa Rica", 630);
			Team tunisia = new Team("Tunisia", 643);
			Team cameroon = new Team("Cameroon", 608);
			Team mexico = new Team("Mexico", 709);
			Team southAfrica = new Team("South Africa", 626); 
			Team senegal = new Team("Senegal", 534);
			
			// CONMEBOL and Asian Teams
			Team china = new Team("China", 562);
			Team saudiArabia = new Team("Saudi Arabia", 628);
			Team ecuador = new Team("Ecuador", 608);
			Team paraguay = new Team("Paraguay", 705);
			Team uruguay = new Team("Uruguay", 656);
			
						
			if (actual) {
			
				groups[A].teams[0] = france;
				groups[A].teams[1] = senegal;
				groups[A].teams[2] = uruguay;
				groups[A].teams[3] = denmark;
				
				groups[B].teams[0] = spain;
				groups[B].teams[1] = slovenia;
				groups[B].teams[2] = paraguay;
				groups[B].teams[3] = southAfrica;
				
				groups[C].teams[0] = brazil;
				groups[C].teams[1] = turkey;
				groups[C].teams[2] = china;
				groups[C].teams[3] = costaRica;
				
				groups[D].teams[0] = koreaRepublic;
				groups[D].teams[1] = poland;
				groups[D].teams[2] = usa;
				groups[D].teams[3] = portugal;
				
				groups[E].teams[0] = germany;
				groups[E].teams[1] = saudiArabia;
				groups[E].teams[2] = republicOfIreland;
				groups[E].teams[3] = cameroon;
				
				groups[F].teams[0] = argentina;
				groups[F].teams[1] = nigeria;
				groups[F].teams[2] = england;
				groups[F].teams[3] = sweden;
				
				groups[G].teams[0] = italy;
				groups[G].teams[1] = ecuador;
				groups[G].teams[2] = croatia;
				groups[G].teams[3] = mexico;
				
				groups[H].teams[0] = japan;
				groups[H].teams[1] = belgium;
				groups[H].teams[2] = russia;
				groups[H].teams[3] = tunisia;
				
			} else {
					
				// Add known seeds
				groups[A].teams[0] = france;
				groups[D].teams[0] = japan;
				groups[H].teams[0] = koreaRepublic;
				
				groups[A].europeanTeams = 1;
				groups[D].asianTeams = 1;
				groups[H].asianTeams = 1;
				
				LinkedList seeds = new LinkedList();
				
				seeds.add(brazil);
				seeds.add(argentina);
				seeds.add(italy);
				seeds.add(spain);
				seeds.add(germany);
				
				LinkedList[] needTeam = { new LinkedList(), 
					new LinkedList(), new LinkedList(), 
					new LinkedList() };
				
				for (int i = 0; i < groups.length; i++) {
					for (int team = 0; team < groups[i].teams.length; team++) {
						if (groups[i].teams[team].initialised == false) {
							needTeam[team].add(groups[i]);
						}
					}
				}
				
				int x;
				Grouping group;
				Team team;
				Random r = new Random();
				
				while (needTeam[0].size() > 0) {
					x = r.nextInt(seeds.size());
					team = (Team) seeds.get(x);
					seeds.remove(x);
					group = (Grouping) needTeam[0].get(0);
					group.teams[0] = team;
					if (team.name == "Brazil" || team.name == "Argentina") {
						group.southAmericanTeams++;
					} else {
						group.europeanTeams++;
					}
					needTeam[0].remove(group);
				}
				
				LinkedList europe = new LinkedList();
				
				europe.add(denmark);
				europe.add(belgium);
				europe.add(croatia);
				europe.add(portugal);
				europe.add(turkey);
				europe.add(russia);
				europe.add(sweden);
				europe.add(slovenia);
				europe.add(england);
				europe.add(republicOfIreland);
				europe.add(poland);
				
				LinkedList europe2 = new LinkedList();
				
				while (europe.size() > 8) {
					team = (Team) europe.get(r.nextInt(europe.size()));
					europe2.add(team);
					europe.remove(team);
				}
						
				for (int i = 0; i < groups.length; i++) {
					team = (Team) europe.get(r.nextInt(europe.size()));
					groups[i].teams[1] = team;
					europe.remove(team);
					groups[i].europeanTeams++;
				}
				
				LinkedList africaAmerica = new LinkedList();
				
				africaAmerica.add(usa);
				africaAmerica.add(nigeria);
				africaAmerica.add(costaRica);
				africaAmerica.add(tunisia);
				africaAmerica.add(cameroon);
				africaAmerica.add(mexico);
				africaAmerica.add(southAfrica);
				africaAmerica.add(senegal);
			
				for (int i = 0; i < groups.length; i++) {
					team = (Team) africaAmerica.get(r.nextInt(africaAmerica.size()));
					groups[i].teams[2] = team;
					africaAmerica.remove(team);
				}
				
				LinkedList asia = new LinkedList();
				
				asia.add(china);
				asia.add(saudiArabia);
				
				LinkedList southAmerica = new LinkedList();
				
				southAmerica.add(ecuador);
				southAmerica.add(paraguay);
				southAmerica.add(uruguay);
		
				/* Only one group has only 1 european team
				 * - randomly determine which
				 */
				LinkedList possibleJokers = new LinkedList();
				
				for (int i = 0; i < groups.length; i++) {
					if (groups[i].europeanTeams < 2) {
						possibleJokers.add(groups[i]);
					}
				}
				
				Grouping onlyOneEuropeanTeam = 
					(Grouping) possibleJokers.get(r.nextInt(possibleJokers.size()));
		
				LinkedList allWithJokerFirst = new LinkedList(possibleJokers);
				allWithJokerFirst.remove(onlyOneEuropeanTeam);
				for (int i = 0; i < groups.length; i++) {
					if (groups[i].europeanTeams == 2) {
						allWithJokerFirst.add(groups[i]);
					}
				}
				allWithJokerFirst.addFirst(onlyOneEuropeanTeam);
		
				LinkedList chooseFrom;
				
				for (int i = 0; i < allWithJokerFirst.size(); i++) {
		
					group = (Grouping) allWithJokerFirst.get(i);
					
					chooseFrom = new LinkedList();
		
					if (group.asianTeams == 0) {
						chooseFrom.addAll(asia);
					}
		
					if (group.southAmericanTeams == 0) {
						chooseFrom.addAll(southAmerica);
					}
					
					if ((group.europeanTeams < 2) && 
					     (! group.equals(onlyOneEuropeanTeam))) {
						chooseFrom = new LinkedList(europe2);
					}
					
					team = (Team) chooseFrom.get(r.nextInt(chooseFrom.size()));
					group.teams[3] = team;
					asia.remove(team);
					southAmerica.remove(team);
					europe2.remove(team);
		
				}
					
			}
			
			
			for (int i = 0; i < groups.length; i++) {
				println("---Group " + WorldCupKoreaJapan.getGroupLetter(i) + "---");
				for (int j = 0; j < groups[i].teams.length; j++) {
					println(groups[i].teams[j].name);
				}
				println();
			}
			
			// write graphic group tables so they're not blank
			for (int i = 0; i < groups.length; i++) {
				groups[i].graphicTable();
			}

			println(getGroupOfDeath());			
			println();	
			
		}
		
		WorldCupDraw() {
				
			this(true);
				
		}

		public String getGroupOfDeath() {
			
			int totalSkill;
			int bestSkill = 0;
			int bestGroup = -1;
			
			for (int i = 0; i < groups.length; i++) {
				totalSkill = 0;
				for (int j = 0; j < groups[i].teams.length; j++) {
					totalSkill = totalSkill + 
					     groups[i].teams[j].skill;
				}
				println("Group " + WorldCupKoreaJapan.getGroupLetter(i) + ": " + totalSkill);
				if (totalSkill > bestSkill) {
					bestGroup = i;
					bestSkill = totalSkill;
				}
			}
			
			return "Group of Death is Group " + WorldCupKoreaJapan.getGroupLetter(bestGroup);
			
		}
			
	}
	

	class Match {
	
		final static int NORMAL_TIME = 0;
		final static int EXTRA_TIME = 1;
		final static int PENALTIES = 2;
		final static int SUDDEN_DEATH = 3;
	
		final static int GROUP = 0;
		final static int KNOCKOUT = 1;
		
		int matchType;
	
		Team[] teams = { 
			new Team(),
			new Team()
		};
		
		String matchDate;
		int[] goals = { 0, 0 };
		int[] penalties = { 0, 0 };
		
		Random r = new Random();

		Match(Team team1, Team team2, 
		    GregorianCalendar calendar, int matchType) {
			
			teams[0] = team1;
			teams[1] = team2;
	
			matchDate = DateFormat.getDateTimeInstance().format(calendar.getTime());
	
			this.matchType = matchType;

			matchesThisWorldCup++;
	    		
		}
		
		Team playMatch() {
			if ((teams[0].name.equals(trackTeamName)) || (teams[1].name.equals(trackTeamName))) {
				trackResults.setText(new Integer(++trackRes).toString() + " from " + numberOfWorldCups + " (avg " + (trackRes / numberOfWorldCups) + ")");
			}
			return this.playMatch(Match.NORMAL_TIME);
		}
	
		Team playMatch(int period) {
			
			int who, other;
			int total = (teams[0].skill * teams[0].skill) + (teams[1].skill * teams[1].skill);
			Random r = new Random();
			int fullTime = r.nextInt(5);
			
			if (period == NORMAL_TIME) {
				println();
				println(teams[0].name + " v " + teams[1].name);
				println();
				println("Start of normal time");
				fullTime = fullTime + 90;	
			} else {
				println("Start of extra time");
				fullTime = fullTime + 30;
			}
			
			for (int i = 1; i <= fullTime; i++) {
				
				if (r.nextInt(total) + 1 <= (teams[0].skill * teams[0].skill)) {
					who = 0;
					other = 1;
				} else {
					who = 1;
					other = 0;
				}
				
				if (r.nextInt(50000) <= ((teams[who].skill * 3) - teams[other].skill)) {
					goals[who]++;
					print(i);
					print(": Goal for " + 
					    teams[who].name + " (" + 
					    goals[0] + " - " + 
					    goals[1] + ")");
					println();
					goalsThisWorldCup++;
					if (period == EXTRA_TIME) {
						// Golden Goal so get out of here
						break;
					}
				}
						
		
			}
					
			println();
			println("Score: " + 
			    teams[0].name + " " + goals[0] + 
			    " - " + goals[1] + " " + teams[1].name);
			
			if (matchType == GROUP) {
				// add to group stats
				teams[0].goalsFor = teams[0].goalsFor + goals[0];
				teams[0].goalsAgainst = teams[0].goalsAgainst + goals[1];
				teams[1].goalsFor = teams[1].goalsFor + goals[1];
				teams[1].goalsAgainst = teams[1].goalsAgainst + goals[0];
				
				if (goals[0] > goals[1]) {
					teams[0].won = teams[0].won + 1;
					teams[1].lost = teams[1].lost + 1;				
				} else if (goals[1] > goals[0]) {
					teams[1].won = teams[1].won + 1;
					teams[0].lost = teams[0].lost + 1;				
				} else {
					teams[0].drawn = teams[0].drawn + 1;
					teams[1].drawn = teams[1].drawn + 1;
				}
			
				return null;
			
			} else if (goals[0] > goals[1]) {
				return teams[0];
			} else if (goals[0] < goals[1]) {
				return teams[1];
			} else if (period == NORMAL_TIME) {
				    return playMatch(EXTRA_TIME);
			} else {
				return penalties(PENALTIES);
			}
					
		}
				
		Team penalties(int period) {
					
			int pens;
			// Number to randomise: higher is lower chance to score
			int penChance;
					
			if (period == PENALTIES) {
				println("Its down to Penalties ...");
				pens = 5;
				// First five are good but progressively worse
				penChance = 900;
			} else {
				pens = 1;
				// Sudden death penalty takers suck
				penChance = 1200;
			}
			
			int thisRoll = 0;
			int otherTeam;
			
			for (int i = 0; i < pens; i++) {
				for (int team = 0; team < teams.length; team++) {
					thisRoll = r.nextInt(penChance + (pens * 25));
					if (thisRoll < teams[team].skill) {
						penalties[team] = penalties[team] + 1;
						println(teams[team].name + " score");
					} else {
						println(teams[team].name + " miss");
					}
					otherTeam = (team == 0 ? 1 : 0);
					if (penalties[team] > 
					    (penalties[otherTeam] + pens - (i + team))) {
							println(penaltyWriteUp(teams, penalties));
						    return teams[team];
					}
					if (penalties[otherTeam] > 
					    (penalties[team] + pens - (i + 1))) {
							println(penaltyWriteUp(teams, penalties));
						    return teams[otherTeam];
					}
				}

				println(penaltyWriteUp(teams, penalties));
		 	 	 
			}
					
			if (penalties[0] > penalties[1]) {
				return teams[0];
			} else if (penalties[0] < penalties[1]) {
				return teams[1];
			} else {
				return penalties(SUDDEN_DEATH);
			}
					
		}			

		String penaltyWriteUp(Team[] teams, int[] penalties) {
			
			String s;
			
			return "Pens: " + teams[0].name + " " +
	 		    penalties[0] + " - " + penalties[1] + " " + 
	 		    teams[1].name;
		}
			
	}


	class Grouping {
		
		public int group;
	
		public int southAmericanTeams = 0;
		public int otherAmericanTeams = 0;
		public int europeanTeams = 0;
		public int asianTeams = 0;
		
		// Must be initialised null for later detection
		LinkedList table;
		
		Grouping(int i) {
			group = i;
		}
		
		public Team[] teams = {
			new Team(),
			new Team(),
			new Team(),
			new Team()
		};
		
		public Team getTeamRanked(int position) {
	
			if (table == null) {
				
				generateTable();
	
			}
				
			return (Team) table.get(position);
					
		}
		
		public void generateTable() {
	
			table = new LinkedList();
				
			LinkedList tempTable = new LinkedList();
			for (int i = 0; i < teams.length; i++) {
				tempTable.add(teams[i]);
			}
			
			Team bestTeam;
			Team team;
				
			while (tempTable.size() > 0) {
					
				bestTeam = (Team) tempTable.getFirst();
	
				for (int i = 0; i < tempTable.size(); i++) {
				
					team = (Team) tempTable.get(i);
	
					if (team.points() > bestTeam.points()) {
							bestTeam = team;
					} else if (team.points() == bestTeam.points() 
				    	&& team.goalDifference() > bestTeam.goalDifference()) {
				        	bestTeam = team;
					} else if (team.points() == bestTeam.points() 
				        && team.goalDifference() == bestTeam.goalDifference()
				        && team.goalsFor > bestTeam.goalsFor) {
				    		bestTeam = team;
					}
				}
					
				table.add(bestTeam);
				tempTable.remove(bestTeam);
				
			}
	
		}
		
		public void writeTable() {
			
			Team team;
			
			if (table == null) {
				generateTable();
			}
			
			println();
			println("               P  W  D  L  F  A  Pts");
			for (int i = 0; i < teams.length; i++) {
				
				team = this.getTeamRanked(i);
				
				print(team.name + " " + 
								 team.played() + "  " + 
				    			 team.won + "  " + team.drawn + 
				    			 "  " + team.lost + "  " + 
				    			 team.goalsFor);
				for (int j = new Integer(team.goalsFor).toString().length(); j < 3; j++) {
					print(" ");
				}
				print(team.goalsAgainst);
				for (int j = new Integer(team.goalsAgainst).toString().length(); j < 3; j++) {
					print(" ");
				}
				print(team.points());
				println();
			}
			
		}
		
		public void graphicTable() {
			
			Team team;
			
			generateTable();
			
			for (int i = 0; i < teams.length; i++) {
				
				team = this.getTeamRanked(i);
				
				groupTables[group].tableData[i][0] = team.name;
				groupTables[group].tableData[i][1] = new Integer(team.played()).toString();
				groupTables[group].tableData[i][2] = new Integer(team.won).toString();
				groupTables[group].tableData[i][3] = new Integer(team.drawn).toString();
				groupTables[group].tableData[i][4] = new Integer(team.lost).toString();
				groupTables[group].tableData[i][5] = new Integer(team.goalsFor).toString();
				groupTables[group].tableData[i][6] = new Integer(team.goalsAgainst).toString();
				groupTables[group].tableData[i][7] = new Integer(team.goalDifference()).toString();
				groupTables[group].tableData[i][8] = new Integer(team.points()).toString();
				
				groupTables[group].updateScreen();
					
			}
			
		}
		
	}

	class GroupTable {
		
		final String[] header = { "Team", "P", "W", "D", 
										  "L", "F", "A", "GD", 
										  "Pts" };
	
		String[][] tableData = new String[4][9];
	
		TableModel dataModel = new AbstractTableModel() {
			
			public int getColumnCount() { 
				return 9;
			}
			public int getRowCount() { 
				return 4;
			}
			public Object getValueAt(int row, int column) {
				return tableData[row][column];
			}
			public String getColumnName(int column) {
				return header[column];
			}
			
		};
		
		JTable table = new JTable(dataModel);
		
		public void updateScreen() {
			table.tableChanged(new TableModelEvent(dataModel));
		}
	
	}
	
}